var $ = jQuery;

$(function () {
    // Секция инициализации
    var optionsViewData = {
        'absence': {
            sendingOption: 'absence',
            messageOK: 'Неявка выставлена',
            messageFail: 'Установка неявки не удалась'
        },
        'absence_unset': {
            sendingOption: null,
            messageOK: 'Неявка отменена',
            messageFail: 'Отмена неявки не удалась'
        },
        'pass': {
            sendingOption: 'pass',
            messageOK: 'Автомат выставлен',
            messageFail: 'Установка автомата не удалась'
        },
        'pass_unset': {
            sendingOption: null,
            messageOK: 'Автомат отменен',
            messageFail: 'Отмена автомата не удалась'
        }
    };
    var json_settings = $.parseJSON($("#hidden_div").html());
    var pageType = $("#pageType").val();
    var cancelFlag = false;
    var g_col;
    var g_row;
    var g_isFocusCell = false; // Стоит фокус на ячейки или нет
    var g_oldRateCell = null;
    var g_submoduleID = null;
    var g_studentID = null;
    var g_submoduleTitle = "";
    var g_submoduleMaxRate = 0;
    var g_stdName = "";

    var jCommonCell = $('.commonCell');
    var jTdInfo_wrap = $("#tdInfo_wrap");
    var jTdInfo = jTdInfo_wrap.children('#tdInfo');
    var g_URL = (window.location.href).split("/");
    var g_disciplineID = g_URL[g_URL.length - 1];

    var onCursorChange = function (cursor) {
        console.log('(' + cursor.row + ', ' + cursor.col + ')\n');
    };

    var cursor = (function (onChange) {
        var col = NaN, row = NaN;
        var self = this;

        return {
            col: function (val) {
                if (typeof val !== 'undefined') {
                    if (onChange) onChange(self);
                    self.col = val;
                }
                return self.col;
            },

            row: function (val) {
                if (typeof val !== 'undefined') {
                    if (onChange) onChange(self);
                    self.row = val;
                }
                return self.row;
            }
        }
    })(onCursorChange);

    //function getDesiredCell(direction) {
    //    /** Будем искать ячейку в направлении {@see direction} до тех пока не найдем её и пока не
    //     *  кончатся ячейки в этом направлении */
    //    var row = g_row;
    //    var col = g_col;
    //    var newCell;
    //
    //
    //    do {
    //        switch (direction) {
    //            case Direction.Up:
    //                row--;
    //                break;
    //            case Direction.Down:
    //                row++;
    //                break;
    //            case Direction.Left:
    //                col--;
    //                break;
    //            case Direction.Right:
    //                col++;
    //                break;
    //        }
    //
    //        newCell = $("tr#row_" + row + " td#col_" + g_col + ".commonCell");
    //    } while ((newCell.length > 0) &&
    //    (newCell.children("input").attr("disabled") == "disabled"));
    //    return newCell;
    //}



    // on page loaded
    // Настройки дисциплины:
    // + ID - id дисциплины
    // + studyGroupID_Filter - studyGroupID для фильтра (Эффект памяти)

    controlVisualization();
    $("div.main_content").ready(AdjustTable);
    $(window).resize(AdjustTable);

    $("#hidden_div").remove();
    filterGroups(json_settings.GroupID_Filter);
    $(".groupSelector [value='" + json_settings.GroupID_Filter + "']").attr("selected", "selected");

    function AdjustTable() {
        var jWrap = $('div.main_layer');
        var jTable = $("div.main_content");
        var tableWidth = jTable.get(0).scrollWidth;
        // check scroll bar
        if (tableWidth <= jTable.width() + 10) {
            return;
        }

        //correct
        tableWidth *= 1.1;
        var maxWidth = $(window).width() * 0.95;
        var newWidth = (tableWidth > maxWidth) ? maxWidth : tableWidth;
        jWrap.css("max-width", newWidth);
    }

    function controlRowVisualization(jRow) {

        if ((pageType !== "exam") || (json_settings.ExamType !== "exam")) {
            return;
        }

        var jAutoPassCheckBox = jRow.children(".autoPass").children(".autoPassCheck");
        var jAbsenceCheckBoxes = jRow.children(".absenceCell").children(".absenceCheck");
        var jExtraInputs = jRow.children(".additionalCell").children(".extra");
        var semesterRate = parseInt(jRow.children(".semesterRateResultCell").text());
        var autopass = jAutoPassCheckBox[0].checked;
        var absence = jAbsenceCheckBoxes[0].checked;
        if (semesterRate < 60 || absence) {
            jAutoPassCheckBox.attr("disabled", true);
        } else {
            jAutoPassCheckBox.removeAttr("disabled");
        }

        // суммарный добор
        var extra = 0;
        jExtraInputs.each(function () {
            extra += $(this).val();
        });

        // чекбоксы влияют на соседей
        var row = parseInt(jRow.attr('id').substr(4)); // одинаковая для всех
        var otherDisabled = false;
        var firstInARow = true;
        jAbsenceCheckBoxes.each(function () {
            var id = $(this).parent().attr('id');
            var col = parseInt(id.substr(8));
            var neighborExam = $("#col_" + col + "_row_" + row);

            $(this).removeAttr("disabled");
            if (autopass || // автомат
                ( firstInARow && (semesterRate < 38) ) || // задолженник
                ( semesterRate + extra < 38 )) // задолженник до сих пор
            {
                $(this).attr("disabled", true);
            }

            // TODO: условия этого и предыдущего if вынести в отдельную функцию, проверяющую допустимость
            if (($(this)[0].checked) || autopass || otherDisabled) { // автомат, неявка или сдал до этого
                neighborExam.children().attr("disabled", true);
            } else {
                if ((firstInARow && (semesterRate < 38)) || // задолженник
                    (semesterRate + extra < 38))  // задолженник до сих пор
                {
                    neighborExam.children().attr("disabled", true);
                } else {
                    neighborExam.children().removeAttr("disabled");
                    if (neighborExam.children().val() === "") {
                        otherDisabled = true;
                    }
                }
            }

            firstInARow = false;
        });
    }

    function controlVisualization() {
        $(".studentsRate").children().children("tr")
            .each(function () {
                if (($(this).prop("id") !== "") && ($(this).attr("id").substr(0, 3) === "row")) {
                    controlRowVisualization($(this));
                }
            });
    }

    // Скрываем все остальные группы
    // 0 - показать все
    function filterGroups(groupID) {
        if (groupID == 0) {
            $(".studentsRate tbody")
                .children()
                .each(function () {
                    $(this).show();
                });
        } else {
            $(".studentsRate tbody")
                .children(":gt(2)")
                .each(function () {
                    if ($(this).hasClass("group_" + groupID))
                        $(this).show();
                    else
                        $(this).hide();
                });
        }
    }

    // Ставим подстветку
    function TdFocus(jThis) {
        var colID = jThis.attr('id');
        cursor.col(parseInt(colID.substr(4)));
        var rowID = jThis.parent('tr').attr('id');
        cursor.row(parseInt(rowID.substr(4)));

        g_oldRateCell = jThis.children("input").val();
        $("td#col_" + cursor.col() + ".commonCell").each(function () {
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        $("td#col_" + cursor.col() + ".staticCell").each(function () {
            $(this).children('input').css("background-color", "#f1f1f1");
        });

        $("tr#row_" + cursor.row() + " .commonCell").each(function () {
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        $("tr#row_" + cursor.row() + " .staticCell").each(function () {
            $(this).css("background-color", "#f1f1f1");
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        jThis.children('input').css("background-color", "#fff");
    }

    // Убираем подстветку
    function TdUnFocus() {
        $("td#col_" + cursor.col() + ".commonCell").each(function () {
            $(this).children('input').css("background-color", "#fff");
        });
        $("td#col_" + cursor.col() + ".staticCell").each(function () {
            $(this).children('input').css("background-color", "#fff");
        });

        $("tr#row_" + cursor.row() + " .commonCell").each(function () {
            $(this).children('input').css("background-color", "#fff");
        });
        $("tr#row_" + cursor.row() + " .staticCell").each(function () {
            $(this).css("background-color", "#fff");
            $(this).children('input').css("background-color", "#fff");
        });
    }

    function TdInfo(jThis) {
        var disciplineType = json_settings.ExamType;
        var disciplinePassRate = 60; // credit pass rate
        if (disciplineType === "exam")
            disciplinePassRate = 38;

        // Получаем подмодуль
        var jCurSubmoduleInfo = $(".RatingTableSubmodulesInfo .col_" + cursor.col() + ":first");
        var jCurSubmoduleHead = $(".RatingTableSubmodulesHead .col_" + cursor.col() + ":first");

        g_submoduleID = parseInt(jCurSubmoduleInfo.attr("id"));
        g_submoduleTitle = jCurSubmoduleHead.text();
        if (jCurSubmoduleHead.length < 1 && $(".RatingTableModulesHead .bonus").length > 0)
            g_submoduleTitle = 'Бонусные баллы';
        g_submoduleMaxRate = parseInt($(".RatingTableSubmodulesHeadMaxRate .col_" + cursor.col()).text());


        // Проверяем допустимое значение (только для добора)
        if (jThis.attr("class").indexOf("additionalCell") >= 0) {
            var semesterRate = parseInt(jThis.siblings(".semesterRateResultCell").text());
            if (semesterRate <= disciplinePassRate)
                g_submoduleMaxRate = disciplinePassRate - semesterRate;
            else
                g_submoduleMaxRate = 0;
        }

        // Получаем студента
        g_studentID = jThis.siblings('.studentCell').attr("id");
        g_studentID = g_studentID.substr(8);

        g_stdName = jThis.siblings('.studentCell').text();

        jTdInfo_wrap.show();
        jTdInfo.children("#student").children("b").html(g_stdName);
        jTdInfo.children("#submodule").children("b").html(g_submoduleTitle);
        jTdInfo.children("#maxRate").children("b").html(g_submoduleMaxRate);

        //if (jThis.children('.tdInfo').length <= 0)
        //  jThis.append("<div class='tdInfo'>"+g_submoduleTitle+"<br>"+g_stdName+"</div>");
    }

    function UnsetTdInfo(jThis) {
        //jThis.children(".tdInfo").remove();
        jTdInfo_wrap.hide();
        g_submoduleID = null;
        g_studentID = null;
        g_submoduleMaxRate = 0;
    }

    function Rating(jThis, oldRate) {
        oldRate = parseInt(oldRate);

        // Здесь jThis - div rateCell, а не input, который является дочкой
        if (cancelFlag) {
            var str = ""
            if (oldRate != -1)
                str = oldRate;
            jThis.children("input").val(str);
            cancelFlag = false;
            return;
        }

        var newRate = -1; // если пустая строка в ячейке, значит ничего не поставлено
        if (jThis.children("input").val() !== "")
            newRate = parseInt(jThis.children("input").val());
        if (newRate == oldRate)
            return;

        // блокируем ячейку пока не обработаем коллбек
        jThis.children("input").attr("disabled", true);

        var rateResult = newRate;

        // считаем баллы по строке
        if (pageType === "exam") //(jThis.attr("class").indexOf("attemptCell") >= 0)
        {
            // страница сессии
            rateResult += parseInt(jThis.siblings(".semesterRateResultCell").text());
            rateResult += parseInt(jThis.siblings(".bonus").text());

            jThis.siblings(".additionalCell").each(function () {
                if ($(this).children("input").val() !== "")
                    rateResult += parseInt($(this).children("input").val());
            });
        }
        else if (pageType === "rating") {
            // страница оценивания
            jThis.siblings(".commonCell").each(function () { // добавим сумму баллов в соседних ячейках
                var rate = $(this).children("input").val();
                if (rate)
                    rateResult += parseInt(rate);
            });

            var additionalRateStr = jThis.siblings(".staticCell").children("p").text();
            if (additionalRateStr)
                rateResult += parseInt(additionalRateStr);
        }

        if (newRate <= g_submoduleMaxRate) {
            $.ajax({
                type: "POST",
                url: URLdir + "handler/rating/setRate",
                data: "studentID=" + g_studentID + "&submoduleID=" + g_submoduleID + "&rate=" + newRate,
                complete: function (jqXHR, textStatus) {
                    switch (jqXHR.status) {
                        case  403:
                            EventInspector_ShowMsg("Сессия истекла", "error");
                            jThis.children("input").val(oldRate);

                            window.location.replace(URLdir);
                            break;
                        case 200:
                            data = $.parseJSON(jqXHR.responseText);
                            if (data.success === true) {
                                var correctRate = (rateResult > 100) ? '100+' : rateResult;
                                jThis.siblings(".rateResultCell").text(correctRate);

                                // Открываем доступ к след. ячейке добора баллов
                                if (jThis.hasClass("additionalCell")) {
                                    nextAdditionalCell = $("#col_" + (cursor.col() + 1) + "_row_" + cursor.row());
                                    placeholder_max = (rateResult <= 60) ? (60 - rateResult) : (60 - oldRate);

                                    if (placeholder_max > 0 && nextAdditionalCell.hasClass("additionalCell")) {
                                        nextAdditionalCell.find("input").attr("placeholder", "макс. " + (placeholder_max));
                                    }
                                }

                                EventInspector_ShowMsg("Балл добавлен/изменен", "success");
                            }
                            else EventInspector_ShowMsg("Не удалось добавить/изменить балл", "error");
                            break;
                        default:
                            EventInspector_ShowMsg(" " + jqXHR.status, "error");
                    }
                }
            });
        }
        else {
            if (oldRate <= g_submoduleMaxRate) {
                if (oldRate != -1)
                    jThis.children("input").val(oldRate);
                else
                    jThis.children("input").val("");
            }
            else
                jThis.children("input").val("0");

            EventInspector_ShowMsg("Текущий балл превышает максимальный для данного модуля", "error");
        }
        jThis.children("input").removeAttr("disabled");
    }

    jCommonCell.mouseenter(function () {
        if (g_isFocusCell === false)
            TdFocus($(this));
    });

    jCommonCell.mouseleave(function () {
        if (g_isFocusCell === false)
            TdUnFocus();
    });

    var oldRate = 0;
    jCommonCell.focusin(function () {
        g_isFocusCell = true;
        TdFocus($(this));
        TdInfo($(this));

        if ($(this).children("input").val() !== "") {
            oldRate = $(this).children("input").val();
        }
        else oldRate = -1;
    });

    jCommonCell.focusout(function () {
        g_isFocusCell = false;
        Rating($(this), oldRate);

        TdUnFocus();
        UnsetTdInfo($(this));
        controlRowVisualization($(this).parent());
    });

    var Direction = {
        Up: 0,
        Right: 1,
        Down: 2,
        Left: 3
    };

    /**
     * @param direction Direction в каком направлении искать следующую ячейку для перемещения фокуса
     * @return jQuery клетка, в которую надо переместиться или null, если в этом направлении нет подходящих ячеек
     */
    function getDesiredCell(direction) {
        /** Будем искать ячейку в направлении {@see direction} до тех пока не найдем её и пока не
         *  кончатся ячейки в этом направлении */
        var row = cursor.row();
        var col = cursor.col();
        var currentCell;
        switch (direction) {
            case Direction.Up:
                do {
                    row--;
                    currentCell = $("tr#row_" + row + " td#col_" + cursor.col() + ".commonCell")
                } while ((currentCell.length > 0) &&
                (currentCell.children("input").attr("disabled") == "disabled"));
                return currentCell;
            case Direction.Right:
                do {
                    col++;
                    currentCell = $("tr#row_" + cursor.row() + " td#col_" + col + ".commonCell")
                } while ((currentCell.length > 0) &&
                (currentCell.children("input").attr("disabled") == "disabled"));
                return currentCell;
            case Direction.Down:
                do {
                    row++;
                    currentCell = $("tr#row_" + row + " td#col_" + cursor.col() + ".commonCell")
                } while ((currentCell.length > 0) &&
                (currentCell.children("input").attr("disabled") == "disabled"));
                return currentCell;
            case Direction.Left:
                do {
                    col--;
                    currentCell = $("tr#row_" + cursor.row() + " td#col_" + col + ".commonCell")
                } while ((currentCell.length > 0) &&
                (currentCell.children("input").attr("disabled") == "disabled"));
                return currentCell;
        }
        return null;
    }

    jCommonCell.keydown(function (e) {
        var row = cursor.row();
        var col = cursor.col();
        var direction;
        switch (e.keyCode) {
            case 27:
                cancelFlag = true; // esc
            case 13: // enter
            case 40: // down arrow
                direction = Direction.Down;
                break;
            case 38: // up arrow
                direction = Direction.Up;
                break;
            case 39: // right arrow
                direction = Direction.Right;
                break;
            case 37: // left arrow
                direction = Direction.Left;
                break;
            default:
                return;
        }
        var whereToMoveFocus = getDesiredCell(direction);
        if (whereToMoveFocus.length > 0) {
            TdUnFocus();
            cursor.col(col);
            cursor.row(row);
            whereToMoveFocus.children("input").focus();
        } else
            $(this).children("input").blur();
    });

    $(".commonCell input").focusin(function () {
        $(this).select();
    });

    // При нажатии на элемент commonCell дочерный input получает фокус
    jCommonCell.click(function () {
        $(this).children("input").focus();
    });

    // В inputCredit (где баллы вводить) разрешаем вводить только цифры
    jCommonCell.children("input").keydown(function (event) {
        KeyDownOnlyNumber(event);
    });

    // Нажатие на чекбокс "Неявка"
    $(".absenceCheck").click(function (event) {
        // prepare
        var option = 'absence';
        var checked = $(this)[0].checked;
        if (!checked)
            option += '_unset';
        var thisTd = $(this).parent();
        cursor.col(thisTd.attr('id').substr(8, 1)); // absence_C
        cursor.row(thisTd.attr('id').substr(10, 1)); // absence_C_R

        // call
        TdInfo(thisTd);
        var errCode = setExamPeriodOption($(this), option);
        UnsetTdInfo(thisTd);

        // test
        if (errCode > 0)
            $(this).prop('checked', !checked); // invert check;
        controlRowVisualization(thisTd.parent());
    });

    $(".autoPassCheck").click(function (event) {
        // prepare
        var option = 'pass';
        var checked = $(this)[0].checked;
        if (!checked)
            option += '_unset';
        var thisTd = $(this).parent();
        cursor.col(thisTd.attr('id').substr(9, 1)); // autopass_C
        cursor.row(thisTd.attr('id').substr(11, 1)); // autopass_C_R

        // call
        TdInfo(thisTd);
        var errCode = setExamPeriodOption($(this), option);
        UnsetTdInfo(thisTd);

        // test
        if (errCode > 0)
            $(this).prop('checked', !checked); // invert check;
        controlRowVisualization(thisTd.parent());
    });


    function setExamPeriodOption(jThis, option) {
        jThis.attr("disabled", true);
        var statusCode = 0;
        $.ajax({
            type: "POST",
            url: URLdir + "handler/rating/SetExamPeriodOption",
            data: "studentID=" + g_studentID + "&submoduleID=" + g_submoduleID +
            "&option=" + optionsViewData[option].sendingOption,
            complete: function (jqXHR, textStatus) {
                statusCode = jqXHR.status;
                switch (jqXHR.status) {
                    case  403:
                        EventInspector_ShowMsg("Сессия истекла", "error");
                        window.location.replace(URLdir);
                    case 200:
                        data = $.parseJSON(jqXHR.responseText);
                        if (data.success === true) {
                            EventInspector_ShowMsg(optionsViewData[option].messageOK, "success");
                            statusCode = 0;
                        }
                        else
                            EventInspector_ShowMsg(optionsViewData[option].messageFail, "error");
                        break;
                    default:
                        EventInspector_ShowMsg(" " + jqXHR.status, "error");
                }
            }
        });
        jThis.removeAttr("disabled");
        return statusCode;
    }

    // Фильтр по группе
    $(".groupSelector").change(function () {
        var group = $(this).val();
        if (group >= 0) {
            filterGroups(group);
            $.post(
                URLdir + "handler/rating/SelectGroup",
                {
                    "disciplineID": g_disciplineID,
                    "groupSelected": group
                },
                function (data) {
                    data = $.parseJSON(data);
                    if (data.success === true) {

                    }
                }
            );
        }
    });

    // Скачать таблицу оценивания в формате excel // depricated
    $(".downloadExcel").click(function () {
        $.fileDownload(URLdir + 'handler/FileCreator/GenerateExcelRatingTable', {
            httpMethod: "POST",
            data: {
                'disciplineID': g_disciplineID
            },
            successCallback: function () {

            },
            failCallback: function () {

            }
        });
    });

    // Ведомость в формате excel
    $('body').on('click', '.downloadExcelStatement', function () {

        var groupID = parseInt($(this).attr("id").substr(6))
        var jStageSelector = $("#stageSelector_" + groupID);

        $.fileDownload(URLdir + 'handler/FileCreator/GenerateFinalForm', {
            httpMethod: "POST",
            data: {
                "disciplineID": g_disciplineID,
                "groupID": groupID,
                "stage": parseInt(jStageSelector.val())
            },
            successCallback: function () {

            },
            failCallback: function () {

            }
        });
    });


});
